/*
*  AQUARIUM
* This is a simple program for managing home aquariums.
* The user can manage the registry of each aquarium and each water changes.
* The program provides, at its launch, issuing a warning signal that warns about the need for a change of water.
*
*   Copyright (C) 2010 - Luigi Ferraris - l3w-info@l3w.it
*
*   This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
*   This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
*   You should have received a copy of the GNU General Public License along with this program. If not, see http://www.gnu.org/licenses/.
*
* release history
* 20101004 - rel. 0.1
*
*/

#include "aquarium.ch"

******************************************************************
* About from definition
******************************************************************
FUNCTION AboutFrm_Define()

SET NAVIGATION EXTENDED
DEFINE WINDOW AboutFrm ;
 ROW 0 ;
 COL 0 ;
 WIDTH 700 ;
 HEIGHT 525 ;
 TITLE "About" ;
 ICON "MAIN_ICO" ;
 MODAL ;
 ON INIT Nil ;
 ON RELEASE Nil ;
 ON INTERACTIVECLOSE Nil ;
 ON MOUSECLICK Nil ;
 ON MOUSEDRAG Nil ;
 ON MOUSEMOVE Nil ;
 ON SIZE Nil ;
 ON PAINT Nil ;
 ON GOTFOCUS Nil ;
 ON LOSTFOCUS Nil ;
 ON SCROLLUP Nil ;
 ON SCROLLDOWN Nil ;
 ON SCROLLLEFT Nil ;
 ON SCROLLRIGHT Nil ;
 ON HSCROLLBOX Nil ;
 ON VSCROLLBOX Nil ;
 FONTNAME FRMFNAME FONTSIZE FRMFSIZE

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT BUTFNAME ;
  SIZE BUTFSIZE ;
  FLAT ;
  BORDER
  BUTTON btExit ;
   CAPTION 'e&Xit' ;
   PICTURE "BTEXIT" ;
   ACTION About_Exit() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "AQUARIUM" WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

 DEFINE LABEL lb_descr
  PARENT AbouFrm
  ROW 60
  COL 20
  VALUE "Managing home aquariums"
  AUTOSIZE .T.
  FONTNAME "Arial"
  FONTSIZE 12
  FONTBOLD .T.
 END LABEL

 DEFINE LABEL lb_ver
  PARENT AbouFrm
  ROW 90
  COL 20
  VALUE "v. 0.1 - 20101004"
  AUTOSIZE .T.
  FONTNAME "Arial"
  FONTSIZE 12
  FONTBOLD .T.
 END LABEL

 DEFINE LABEL lb_author
  PARENT AbouFrm
  ROW 120
  COL 20
  VALUE "Luigi Ferraris"
  AUTOSIZE .T.
  FONTNAME "Arial"
  FONTSIZE 12
  FONTBOLD .T.
 END LABEL

 DEFINE HYPERLINK website
  PARENT AbouFrm
  ROW 150
  COL 20
  FONTNAME "Arial"
  FONTSIZE 12
  FONTBOLD .T.
  VALUE "www.L3W.it"
  ADDRESS "http://www.l3w.it"
  HANDCURSOR .T.
  AUTOSIZE .T.
 END HYPERLINK

 DEFINE HYPERLINK email
  PARENT AbouFrm
  ROW 180
  COL 20
  FONTNAME "Arial"
  FONTSIZE 12
  FONTBOLD .T.
  VALUE "l3w-info@l3w.it"
  ADDRESS "l3w-info@l3w.it"
  HANDCURSOR .F.
  AUTOSIZE .T.
 END HYPERLINK

END WINDOW

AboutFrm.Center

RETURN NIL

******************************************************************
* Exit function
******************************************************************
STATIC FUNCTION About_Exit()
AboutFrm.Hide
RETURN NIL

******************************************************************
* Show form
******************************************************************
FUNCTION About_Main()
AboutFrm.Restore
AboutFrm.SetFocus
RETURN NIL
