/*
*  AQUARIUM - miscellaneous functions
*/

#include "aquarium.ch"

* Check dbf consistency
FUNCTION ChkEnv()
LOCAL lProceed := .T.
LOCAL cDbfFile := "", cPath := PathMerge( pbcCurPath, pbcDataPath )
LOCAL aStru := {}

* create data directory
IF !HB_DIREXISTS( cPath )
 MAKEDIR( cPath )
ENDIF

* progress
cDbfFile := HB_FNAMEMERGE( cPath, "progress", ".dbf")
IF !FILE( cDbfFile )
 aStru := {}
 AADD( aStru, { "admintstp", "C", 017, 000 }) // Upd.timer  yyyymmddhhmmssnnn es. 201003121425221
 AADD( aStru, { "prgidcode", "C", 008, 000 }) // progressive code
 AADD( aStru, { "prgdescri", "C", 255, 000 }) // progressive description
 AADD( aStru, { "prglstval", "N", 008, 000 }) // last value
 DBCREATE( cDbfFile, aStru, DBSETDRIVER(), .T., "progress" )
* waiting
 INKEY( NET_WAIT )
 IF !FILE( cDbfFile )
  MSGSTOP( "Can not create" + HB_OSNEWLINE() + cDbfFile )
  lProceed := .F.
 ELSE
  IF Addrec("progress")
   progress->admintstp := HB_TTOS(HB_DATETIME())
   progress->prgidcode := "LSTAQUAR"
   progress->prgdescri := "Last AQUARIUM code"
   progress->prglstval := 0
   progress->(DBCOMMIT())
  ENDIF
  progress->( DBCLOSEAREA() )
 ENDIF
ENDIF

* taquanag
cDbfFile := HB_FNAMEMERGE( cPath, "taquanag", ".dbf")
IF !FILE( cDbfFile )
 aStru := {}
 AADD( aStru, { "admintstp", "C", 017, 000 }) // Upd.timer  yyyymmddhhmmssnnn es. 201003121425221
 AADD( aStru, { "taqidcode", "C", 008, 000 }) // aquarium code
 AADD( aStru, { "taqdescri", "C", 255, 000 }) // aquarium description
 AADD( aStru, { "taqextwid", "N", 005, 001 }) // external width
 AADD( aStru, { "taqexthei", "N", 005, 001 }) // external height
 AADD( aStru, { "taqextdep", "N", 005, 001 }) // external depth
 AADD( aStru, { "taqglswid", "N", 003, 001 }) // thick glass on width
 AADD( aStru, { "taqglshei", "N", 003, 001 }) // thick glass on height
 AADD( aStru, { "taqglsdep", "N", 003, 001 }) // thick glass on depth
 AADD( aStru, { "taqtopmrg", "N", 002, 000 }) // water top margin
 AADD( aStru, { "taqthkbot", "N", 003, 001 }) // thick bottom
 AADD( aStru, { "taqfltwid", "N", 005, 001 }) // filter width
 AADD( aStru, { "taqflthei", "N", 005, 001 }) // filter height
 AADD( aStru, { "taqfltdep", "N", 005, 001 }) // filter depth
 AADD( aStru, { "taqrocvol", "N", 009, 002 }) // rocks volume
 AADD( aStru, { "taqothvol", "N", 009, 002 }) // other volume
 AADD( aStru, { "taqnetvol", "N", 012, 002 }) // net volume
 AADD( aStru, { "taqnetlit", "N", 009, 002 }) // net liters
 AADD( aStru, { "taqlgtwat", "N", 006, 000 }) // light Watt
 AADD( aStru, { "taqpmplth", "N", 007, 000 }) // pump L/h
 AADD( aStru, { "taqchgper", "N", 003, 000 }) // % liters change
 AADD( aStru, { "taqchgday", "N", 003, 000 }) // change every n days
 DBCREATE( cDbfFile, aStru, DBSETDRIVER(), .T., "taquanag" )
* waiting
 INKEY( NET_WAIT )
 IF !FILE( cDbfFile )
  MSGSTOP( "Can not create" + HB_OSNEWLINE() + cDbfFile )
  lProceed := .F.
 ELSE
  taquanag->( DBCLOSEAREA() )
 ENDIF
ENDIF

* chgwater
cDbfFile := HB_FNAMEMERGE( cPath, "chgwater", ".dbf")
IF !FILE( cDbfFile )
 aStru := {}
 AADD( aStru, { "admintstp", "C", 017, 000 }) // Upd.timer  yyyymmddhhmmssnnn es. 201003121425221
 AADD( aStru, { "chwidaqua", "C", 008, 000 }) // aquarium code
 AADD( aStru, { "chwdatech", "C", 008, 000 }) // date yyyymmdd
 AADD( aStru, { "chwliters", "N", 009, 002 }) // changed liters
 AADD( aStru, { "chwpercen", "N", 003, 000 }) // changed in %
 AADD( aStru, { "chwnotess", "C", 255, 000 }) // note
 DBCREATE( cDbfFile, aStru, DBSETDRIVER(), .T., "chgwater" )
* waiting
 INKEY( NET_WAIT )
 IF !FILE( cDbfFile )
  MSGSTOP( "Can not create" + HB_OSNEWLINE() + cDbfFile )
  lProceed := .F.
 ELSE
  chgwater->( DBCLOSEAREA() )
 ENDIF
ENDIF

* check indexs
IF lProceed == .T.

* progress indexes
 IF !FILE( HB_FNAMEMERGE( cPath, "progres1", ".ntx") ) .OR. !FILE( HB_FNAMEMERGE( cPath, "progres2", ".ntx") )
  IF DBUSEAREA( .T., DBSETDRIVER(), HB_FNAMEMERGE( cPath, "progress", ".dbf"), "progress", .F., .F. )
   SELECT("progress")
   IF !FILE( HB_FNAMEMERGE( cPath, "progres1", ".ntx") )
    INDEX ON prgidcode TO (HB_FNAMEMERGE( cPath, "progres1", ".ntx")) UNIQUE
    INKEY( NET_WAIT )
    IF !FILE( HB_FNAMEMERGE( cPath, "progres1", ".ntx") )
     MSGSTOP( "progress index 1 not created" )
     lProceed := .F.
    ENDIF
   ENDIF
   IF !FILE( HB_FNAMEMERGE( cPath, "progres2", ".ntx") )
    INDEX ON prgdescri TO (HB_FNAMEMERGE( cPath, "progres2", ".ntx")) UNIQUE
    INKEY( NET_WAIT )
    IF !FILE( HB_FNAMEMERGE( cPath, "progres2", ".ntx") )
     MSGSTOP( "progress index 2 not created" )
     lProceed := .F.
    ENDIF
   ENDIF
   progress->( DBCLOSEAREA() )
  ELSE
   MSGSTOP( "Can't open progress in Exclusive mode" )
  ENDIF
 ENDIF

* taquanag indexes
 IF !FILE( HB_FNAMEMERGE( cPath, "taquana1", ".ntx") ) .OR. !FILE( HB_FNAMEMERGE( cPath, "taquana2", ".ntx") )
  IF DBUSEAREA( .T., DBSETDRIVER(), HB_FNAMEMERGE( cPath, "taquanag", ".dbf"), "taquanag", .F., .F. )
   SELECT("taquanag")
   IF !FILE( HB_FNAMEMERGE( cPath, "taquana1", ".ntx") )
    INDEX ON taqidcode TO (HB_FNAMEMERGE( cPath, "taquana1", ".ntx")) UNIQUE
    INKEY( NET_WAIT )
    IF !FILE( HB_FNAMEMERGE( cPath, "taquana1", ".ntx") )
     MSGSTOP( "taquanag index 1 not created" )
     lProceed := .F.
    ENDIF
   ENDIF
   IF !FILE( HB_FNAMEMERGE( cPath, "taquana2", ".ntx") )
    INDEX ON taqdescri TO (HB_FNAMEMERGE( cPath, "taquana2", ".ntx"))
    INKEY( NET_WAIT )
    IF !FILE( HB_FNAMEMERGE( cPath, "taquana2", ".ntx") )
     MSGSTOP( "taquanag index 2 not created" )
     lProceed := .F.
    ENDIF
   ENDIF
   taquanag->( DBCLOSEAREA() )
  ELSE
   MSGSTOP( "Can't open taquanag in Exclusive mode" )
  ENDIF
 ENDIF

* chgwater indexes
 IF !FILE( HB_FNAMEMERGE( cPath, "chgwate1", ".ntx") )
  IF DBUSEAREA( .T., DBSETDRIVER(), HB_FNAMEMERGE( cPath, "chgwater", ".dbf"), "chgwater", .F., .F. )
   SELECT("chgwater")
   IF !FILE( HB_FNAMEMERGE( cPath, "chgwate1", ".ntx") )
    INDEX ON chwidaqua+chwdatech TO (HB_FNAMEMERGE( cPath, "chgwate1", ".ntx")) UNIQUE
    INKEY( NET_WAIT )
    IF !FILE( HB_FNAMEMERGE( cPath, "chgwate1", ".ntx") )
     MSGSTOP( "chgwater index 1 not created" )
     lProceed := .F.
    ENDIF
   ENDIF
   chgwater->( DBCLOSEAREA() )
  ELSE
   MSGSTOP( "Can't open chgwater in Exclusive mode" )
  ENDIF
 ENDIF

ENDIF

RETURN lProceed

/***************************************************************
* Open Tables
***************************************************************/
FUNCTION OpenTab()
LOCAL lProceed := .T.
LOCAL cDbfFile := "", cPath := PathMerge( pbcCurPath, pbcDataPath )

IF DBUSEAREA( .T., DBSETDRIVER(), HB_FNAMEMERGE( cPath, "progress", ".dbf"), "progress", .T., .F. ) == .F. .OR. ;
   DBUSEAREA( .T., DBSETDRIVER(), HB_FNAMEMERGE( cPath, "taquanag", ".dbf"), "taquanag", .T., .F. ) == .F. .OR. ;
   DBUSEAREA( .T., DBSETDRIVER(), HB_FNAMEMERGE( cPath, "chgwater", ".dbf"), "chgwater", .T., .F. ) == .F.
 MSGSTOP( "Can not open one or more table" )
 lProceed := .F.
ENDIF

* try to open or create indexs
IF lProceed == .T.
 IF ("progress")->(ORDLISTADD(HB_FNAMEMERGE( cPath, "progres1", ".ntx"))) == .F. .OR. ;
    ("progress")->(ORDLISTADD(HB_FNAMEMERGE( cPath, "progres2", ".ntx"))) == .F. .OR. ;
    ("taquanag")->(ORDLISTADD(HB_FNAMEMERGE( cPath, "taquana1", ".ntx"))) == .F. .OR. ;
    ("taquanag")->(ORDLISTADD(HB_FNAMEMERGE( cPath, "taquana2", ".ntx"))) == .F. .OR. ;
    ("chgwater")->(ORDLISTADD(HB_FNAMEMERGE( cPath, "chgwate1", ".ntx"))) == .F.
  MSGSTOP( "Can not open one or more index" )
  lProceed := .F.
 ENDIF
ENDIF

RETURN lProceed

/***************************************************************
* FormFree
***************************************************************/
FUNCTION IsFomFree( cFormName, cFormControl, cCheckStatus )
LOCAL lFree := .T.
cCheckStatus := IF( VALTYPE( cCheckStatus ) == "C", ALLTRIM( UPPER( cCheckStatus ) ), "E" )
IF _IsControlDefined( cFormControl, cFormName  )
 IF GetProperty( cFormName, cFormControl, "Value" ) <> cCheckStatus
  lFree := .F.
 ENDIF
ENDIF
IF lFree == .F.
 MSGSTOP( "Form "+ cFormName + " in use")
ENDIF
RETURN lFree

/***************************************************************
* Merge Directories name
***************************************************************/
FUNCTION PathMerge( Arg1, Arg2 )
LOCAL cReturn := ""

cReturn := ALLTRIM( Arg1 )
IF RIGHT( cReturn, 1 ) <> HB_OSPATHSEPARATOR()
 cReturn += HB_OSPATHSEPARATOR()
ENDIF
cReturn += IF( LEFT( ALLTRIM( Arg2 ), 1 ) == HB_OSPATHSEPARATOR(), SUBSTR( ALLTRIM( Arg2 ), 2 ), ALLTRIM( Arg2 ) )

RETURN cReturn

/***************************************************************
* enable form fields
***************************************************************/
FUNCTION AllEnabled(cFormName, aList)
LOCAL nI := 0
IF VALTYPE(aList) == "A"
 FOR nI := 1 TO LEN(aList)
  IF _IsControlDefined( aList[nI], cFormName  )
   SetProperty( cFormName , aList[nI] , 'Enabled' , .T. )
  ENDIF
 NEXT nI
ENDIF
RETURN NIL

/***************************************************************
* disable form fields
***************************************************************/
FUNCTION AllDisabled(cFormName, aList)
LOCAL nI := 0
IF VALTYPE(aList) == "A"
 FOR nI := 1 TO LEN(aList)
  IF _IsControlDefined( aList[nI], cFormName  )
   SetProperty( cFormName , aList[nI] , 'Enabled' , .F. )
  ENDIF
 NEXT nI
ENDIF
RETURN NIL

/***************************************************************
* fill a key
***************************************************************/
FUNCTION FillKey(cValue, nLen)
LOCAL cFilled := SUBSTR( cValue + SPACE(nLen), 1 , nLen )
RETURN cFilled

/***************************************************************
* try to lock a record
***************************************************************/
FUNCTION RecLock(cAliasName, nRecNum)
LOCAL lLock := .F.
LOCAL cAlias := IIF(VALTYPE(cAliasName)=="C", ALLTRIM(cAliasName), "")
LOCAL nSeconds := NET_SECS * 2
LOCAL nCurArea := SELECT(), nArea := 0
LOCAL nNumRec := 0
nArea := IIF(LEN(cAlias)>0, SELECT(cAlias), SELECT())
IF nArea<>0
 DBSELECTAREA(nArea)
 IF VALTYPE(nRecNum)=="N" .AND. nRecNum>0 .AND. nRecNum<=LASTREC()
  nNumRec := nRecNum
 ELSE
  nNumrec := RECNO()
 ENDIF
 IF DBRLOCK(nNumRec)
  lLock := .T.
 ELSE
  WAIT WINDOW "Record Lock Processing..."  NOWAIT
  WHILE nSeconds>0
   DO EVENTS
   IF DBRLOCK(nNumRec)
    lLock := .T.
    EXIT
   ELSE
* waiting
    INKEY(NET_WAIT)
    nSeconds -= NET_WAIT
   ENDIF
  END
  WAIT CLEAR
 ENDIF
ENDIF
DBSELECTAREA(nCurArea)
RETURN lLock

/***************************************************************
* UNlock a record
***************************************************************/
FUNCTION RecUnlock(cAliasName, nRecNum)
LOCAL lUnLock := .F.
LOCAL cAlias := IIF(VALTYPE(cAliasName)=="C", ALLTRIM(cAliasName), "")
LOCAL nSeconds := NET_SECS * 2
LOCAL nCurArea := SELECT(), nArea := 0
LOCAL nNumRec := 0
nArea := IIF(LEN(cAlias)>0, SELECT(cAlias), SELECT())
IF nArea<>0
 DBSELECTAREA(nArea)
 IF VALTYPE(nRecNum)=="N" .AND. nRecNum>0 .AND. nRecNum<=LASTREC()
  nNumRec := nRecNum
 ELSE
  nNumrec := RECNO()
 ENDIF
 DBRUNLOCK(nNumRec)
 lUnlock := .T.
ENDIF
DBSELECTAREA(nCurArea)
RETURN lUnlock

/***************************************************************
* Try to add record
***************************************************************/
FUNCTION Addrec(cAliasName, lReleaseRecLocks)
LOCAL lAddRec := .F.
LOCAL cAlias := IIF(VALTYPE(cAliasName)=="C", ALLTRIM(cAliasName), "")
LOCAL lRelease := IIF(VALTYPE(lReleaseRecLocks)=="L", lReleaseRecLocks, .T.)
LOCAL nSeconds := NET_SECS * 2
LOCAL nCurArea := SELECT(), nArea := 0
nArea := IIF(LEN(cAlias)>0, SELECT(cAlias), SELECT())
IF nArea<>0
 DBSELECTAREA(nArea)
 DBAPPEND(lRelease)
 IF !NETERR()
  lAddRec := .T.
 ELSE
  WAIT WINDOW "Record Add Processing..."  NOWAIT
  WHILE nSeconds>0
   DO EVENTS
   DBAPPEND(lRelease)
   IF !NETERR()
    lAddRec := .T.
    EXIT
   ELSE
* waiting
    INKEY(NET_WAIT)
    nSeconds -= NET_WAIT
   ENDIF
  END
  WAIT CLEAR
 ENDIF
ENDIF
DBSELECTAREA(nCurArea)
RETURN lAddRec
