/*
*  AQUARIUM
* This is a simple program for managing home aquariums.
* The user can manage the registry of each aquarium and each water changes.
* The program provides, at its launch, issuing a warning signal that warns about the need for a change of water.
*
*   Copyright (C) 2010 - Luigi Ferraris - l3w-info@l3w.it
*
*   This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
*   This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
*   You should have received a copy of the GNU General Public License along with this program. If not, see http://www.gnu.org/licenses/.
*
* release history
* 20101004 - rel. 0.1
*/

#include "aquarium.ch"

FUNCTION main()
PUBLIC pbcCurPath := GetCurrentFolder()
PUBLIC pbcDataPath := "Dat"
SET( _SET_EPOCH, 2000 )
SET CENTURY ON
SET( _SET_DATEFORMAT, "dd-mm-yyyy" )

DefineForms()

ACTIVATE WINDOW ALL

DBCLOSEALL()

RETURN Nil

/*
* this function define all forms
*/
STATIC FUNCTION DefineForms()

p000Frm_Define()
p002Frm_Define()
p003Frm_Define()
p004Frm_Define()
p005Frm_Define()
p100Frm_Define()
p101Frm_Define()
p999Frm_Define()
AboutFrm_Define()

RETURN Nil

/*
* p000Frm definition
*/
STATIC FUNCTION p000Frm_Define()

SET NAVIGATION EXTENDED
DEFINE WINDOW p000Frm ;
 ROW 0 ;
 COL 0 ;
 WIDTH 980 ;
 HEIGHT 735 ;
 WINDOWTYPE MAIN ;
 TITLE "L3W - Aquarium (v. 0.1) :: main menu" ;
 ICON "MAIN_ICO" ;
 VISIBLE .T. ;
 MINBUTTON .T. ;
 MAXBUTTON .T. ;
 SIZABLE .T. ;
 SYSMENU .T. ;
 TITLEBAR .T. ;
 ON INIT p000Frm_OnInit() ;
 ON RELEASE Nil ;
 ON INTERACTIVECLOSE Nil ;
 ON MOUSECLICK Nil ;
 ON MOUSEDRAG Nil ;
 ON MOUSEMOVE Nil ;
 ON SIZE Nil ;
 ON MAXIMIZE Nil ;
 ON MINIMIZE Nil ;
 ON PAINT Nil ;
 FONTNAME FRMFNAME FONTSIZE FRMFSIZE ;
 NOTIFYICON "MAIN_ICO" ;
 NOTIFYTOOLTIP "L3W - Aquarium" ;
 ON NOTIFYCLICK Nil ;
 ON GOTFOCUS Nil ;
 ON LOSTFOCUS Nil ;
 ON SCROLLUP Nil ;
 ON SCROLLDOWN Nil ;
 ON SCROLLLEFT Nil ;
 ON SCROLLRIGHT Nil ;
 ON HSCROLLBOX Nil ;
 ON VSCROLLBOX Nil

 DEFINE MAIN MENU
  DEFINE POPUP '&File'
   MENUITEM 'e&Xit' ACTION p000Frm_Exit()
  END POPUP
  DEFINE POPUP '&Water'
   MENUITEM '&Change' ACTION p100_Main( {"p000Frm"} )
   MENUITEM '&Status' ACTION p999_Main()
  END POPUP
  DEFINE POPUP '&Table'
   MENUITEM '&Aquarium' ACTION p004_Main( {"p000Frm"} )
   MENUITEM '&Progress' ACTION p002_Main( {"p000Frm"} )
  END POPUP
  DEFINE POPUP '&About'
   MENUITEM '&Who am I' ACTION About_Main()
  END POPUP
 END MENU

 DEFINE STATUSBAR
  STATUSITEM "AQUARIUM" WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

END WINDOW

p000Frm.Center
RETURN NIL

/****************************************************************
* p000Frm OnInit event
****************************************************************/
STATIC FUNCTION p000Frm_OnInit()
IF ChkEnv() == .F.
 MSGSTOP( "Sorry! There is some problem. Can't continue" )
 p000Frm_Exit()
ELSEIF OpenTab() == .F.
 p000Frm_Exit()
ELSE
 p999_Main()
ENDIF
RETURN Nil

/***************************************************************
* p000Frm menu exit event
***************************************************************/
STATIC FUNCTION p000Frm_Exit()
RELEASEALLWINDOWS()
RETURN Nil
