/*
*  AQUARIUM - manage progress
*/

#include "aquarium.ch"

/*
* p003Frm definition
*/
FUNCTION p003Frm_Define()

SET NAVIGATION EXTENDED
DEFINE WINDOW p003Frm ;
 ROW 0 ;
 COL 0 ;
 WIDTH 860 ;
 HEIGHT 645 ;
 WINDOWTYPE STANDARD ;
 TITLE "Progressive MANAGER (p003Frm)" ;
 ICON "MAIN_ICO" ;
 VISIBLE .T. ;
 MINBUTTON .T. ;
 MAXBUTTON .F. ;
 SIZABLE .F. ;
 SYSMENU .T. ;
 TITLEBAR .T. ;
 ON INIT Nil ;
 ON RELEASE Nil ;
 ON INTERACTIVECLOSE p003Frm_OnIntClose() ;
 ON MOUSECLICK Nil ;
 ON MOUSEDRAG Nil ;
 ON MOUSEMOVE Nil ;
 ON SIZE Nil ;
 ON MAXIMIZE Nil ;
 ON MINIMIZE Nil ;
 ON PAINT Nil ;
 FONTNAME FRMFNAME FONTSIZE FRMFSIZE ;
 ON NOTIFYCLICK Nil ;
 ON GOTFOCUS Nil ;
 ON LOSTFOCUS Nil ;
 ON SCROLLUP Nil ;
 ON SCROLLDOWN Nil ;
 ON SCROLLLEFT Nil ;
 ON SCROLLRIGHT Nil ;
 ON HSCROLLBOX Nil ;
 ON VSCROLLBOX Nil

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT BUTFNAME ;
  SIZE BUTFSIZE ;
  FLAT ;
  BORDER
  BUTTON btExit ;
   CAPTION 'e&Xit' ;
   PICTURE "BTEXIT" ;
   ACTION p003_Exit() ;
   SEPARATOR
  BUTTON btSave ;
   CAPTION '&Save' ;
   PICTURE "BTSAVE" ;
   ACTION p003_Save() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "AQUARIUM" WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* E=empty form, 0=form in use and record not found, 1=form in use and record found and lock, 2=form in use and record found and lock and already deleted
 DEFINE LABEL FormStatus
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "E"
  VISIBLE .F.
 END LABEL

* label prgidcode
 DEFINE LABEL lb_prgidcode
  ROW 60
  COL 20
  VALUE 'Code'
  ONCLICK  Nil
  WIDTH 100
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Code'
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Right
  VISIBLE .T.
 END LABEL
* field prgidcode
 DEFINE TEXTBOX prgidcode
  ROW 60
  COL 125
  HEIGHT 25
  WIDTH 100
  VALUE ""
  READONLY .F.
  INPUTMASK Nil
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Code'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE CHARACTER
  MAXLENGTH 8
  CASECONVERT UPPER
  ONGOTFOCUS Nil
  ONCHANGE Nil
  ONLOSTFOCUS Nil
  ONENTER p003_Enter()
  RIGHTALIGN .F.
  VISIBLE .T.
  TABSTOP .T.
 END TEXTBOX

* label prgdescri
 DEFINE LABEL lb_prgdescri
  ROW 90
  COL 20
  VALUE 'Description'
  ONCLICK  Nil
  WIDTH 100
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Description'
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Right
  VISIBLE .T.
 END LABEL
* field prgdescri
 DEFINE TEXTBOX prgdescri
  ROW 90
  COL 125
  HEIGHT 25
  WIDTH 200
  VALUE ""
  READONLY .F.
  INPUTMASK Nil
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Description'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE CHARACTER
  MAXLENGTH 255
  CASECONVERT NONE
  ONGOTFOCUS Nil
  ONCHANGE Nil
  ONLOSTFOCUS Nil
  ONENTER p003_prgdescri()
  RIGHTALIGN .F.
  VISIBLE .T.
  TABSTOP .T.
 END TEXTBOX

* field prglstval
 DEFINE LABEL lb_prglstval
  ROW 120
  COL 20
  VALUE 'Value'
  ONCLICK  Nil
  WIDTH 100
  HEIGHT 25
  AUTOSIZE .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Value'
  BACKCOLOR Nil
  FONTCOLOR Nil
  TRANSPARENT .T.
  ALIGNMENT Right
  VISIBLE .T.
 END LABEL
* field prglstval
 DEFINE TEXTBOX prglstval
  ROW 120
  COL 125
  HEIGHT 25
  WIDTH 150
  VALUE 0
  READONLY .F.
  INPUTMASK '99,999,999'
  FORMAT Nil
  PASSWORD .F.
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Value'
  BACKCOLOR Nil
  FONTCOLOR Nil
  DATATYPE NUMERIC
  ONGOTFOCUS Nil
  ONCHANGE Nil
  ONLOSTFOCUS Nil
  ONENTER p003_prglstval()
  RIGHTALIGN .T.
  VISIBLE .T.
  TABSTOP .T.
 END TEXTBOX

END WINDOW

p003Frm.Center
RETURN NIL

/****************************************************************
* pgm002 Entry function
* aParm[1] = form name to assign focus when leave this form
* aParm[2] = control name (about prev. form name) to assign focus when leave this form
* aParm[3] = control name (about prev. form name) to assign a value from grid of this form
* aParm[n] = control name (about prev. form name) to assign a value from grid of this form
* nGrid = if passed when load grid set Grid.Value else is set to 1
****************************************************************/
FUNCTION p003_Main( aParm, nGrid)
LOCAL lReturn := .F.
IF IsFomFree( "p003Frm", "FormStatus", "E" )
 p003_ShowForm( aParm, nGrid)
 lReturn := .T.
ELSE
 p003_NewFocus(aParm)
ENDIF
RETURN lReturn

/****************************************************************
* Show form
****************************************************************/
STATIC FUNCTION p003_ShowForm( aParm, nGrid)
LOCAL aTemp := {}
PUBLIC p003_nGrid := IF( VALTYPE( nGrid ) == "N", nGrid, 0 )
PUBLIC p003_aParm := IF( VALTYPE( aParm ) == "A", aParm, {} )
p003Frm.Restore
p003Frm.Setfocus

IF p003_nGrid <> 0
 aTemp := GetProperty("p002Frm", "grid1", "item", p003_nGrid)
 p003Frm.prgidcode.Value := aTemp[1]
 p003Frm.prgidcode.SetFocus
 p003_Enter()
ENDIF

RETURN NIL

/****************************************************************
* Set New Focus
* __MVEXIST, __MVGET, __MVPUT are little trick because p003_aParm is declared PUBLIC inside in p003_ShowForm function
* but p003_NewFocus can be called from p003_Main and p003_aParm it's not declared!
****************************************************************/
STATIC FUNCTION p003_NewFocus( aParm )
LOCAL aNewFocus := IF( VALTYPE( aParm ) == "A", aParm, IF( __MVEXIST("p003_aParm"), __MVGET("p003_aParm"), {} ) )
IF LEN(aNewFocus)>=1
 DoMethod(aNewFocus[1], "Restore" )
 IF LEN(aNewFocus)==1
  DoMethod(aNewFocus[1], "SetFocus")
 ELSEIF LEN(aNewFocus)>=2
  DoMethod(aNewFocus[1], aNewFocus[2], "SetFocus")
 ENDIF
ENDIF
IF __MVEXIST("p003_aParm")
 __MVPUT("p003_aParm", {})
ENDIF
RETURN NIL

/****************************************************************
* p003Frm OnIntercativeClose event
****************************************************************/
STATIC FUNCTION p003Frm_OnIntClose()
p003_FormReset()
p003_NewFocus()
RETURN NIL

/****************************************************************
* Form Reset function
****************************************************************/
STATIC FUNCTION p003_FormReset()
progress->(DBUNLOCK())

p003Frm.FormStatus.Value := "E"
p003Frm.prgidcode.Value := ""
p003Frm.prgdescri.Value := ""
p003Frm.prglstval.Value := 0

p003Frm.prgidcode.Enabled := .T.
p003Frm.prgdescri.Enabled := .F.
p003Frm.prglstval.Enabled := .F.
p003Frm.prgidcode.SetFocus

p003Frm.btSave.Enabled := .F.

RETURN NIL

/****************************************************************
* Exit event
****************************************************************/
STATIC FUNCTION p003_Exit()
p003_FormReset()
p003Frm.Hide
p003_NewFocus()
RETURN NIL

/****************************************************************
* Save function
****************************************************************/
STATIC FUNCTION p003_Save()
IF p003_CheckData() == .T.
 IF p003_Update()
  p003_FormReset()
  p003Frm.Hide
  p003_NewFocus()
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Enter function
****************************************************************/
STATIC FUNCTION p003_Enter()
IF p003_prgidcode() == .T.
 p003_Getrec()
ENDIF
RETURN NIL

/****************************************************************
* Retrieve record
****************************************************************/
STATIC FUNCTION p003_Getrec()
LOCAL cKey := FillKey( p003Frm.prgidcode.Value, 8 )

progress->(ORDSETFOCUS(1))
IF progress->(DBSEEK(cKey, .F.)) == .T.
 IF Reclock("progress") == .T.
  p003Frm.FormStatus.Value := "1"
  IF progress->(DELETED())
   p003Frm.FormStatus.Value := "2"
  ENDIF
  p003_LoadForm()
 ELSE
  MSGSTOP("Record LOCKED","p003_Getrec()")
 ENDIF
ELSE
 p003Frm.FormStatus.Value := "0"
 p003_LoadForm()
ENDIF
RETURN NIL

/****************************************************************
* Load form function
****************************************************************/
STATIC FUNCTION p003_LoadForm()
IF p003Frm.FormStatus.Value <> "0"
 p003Frm.prgdescri.Value := progress->prgdescri
 p003Frm.prglstval.Value := progress->prglstval
ENDIF
p003Frm.prgidcode.Enabled := .F.
p003Frm.prgdescri.Enabled := .T.
p003Frm.prglstval.Enabled := .T.
p003Frm.prgdescri.SetFocus

p003Frm.btSave.Enabled := .T.
RETURN NIL

/****************************************************************
* Update function
****************************************************************/
STATIC FUNCTION p003_Update()
LOCAL lDone := .T., lRiattiva := .F.

IF p003Frm.FormStatus.Value == "0" .AND. Addrec("progress") == .F.
 MSGSTOP( "Can't add new record","p003_update()")
 lDone:=.F.
ENDIF
IF p003Frm.FormStatus.Value == "2"
 lRiattiva := MSGYESNO("Reactivate record?" )
ENDIF
IF lDone == .T.
 progress->admintstp := HB_TTOS(HB_DATETIME())
 IF p003Frm.FormStatus.Value == "0"
  progress->prgidcode := p003Frm.prgidcode.Value
 ENDIF
 progress->prgdescri := p003Frm.prgdescri.Value
 progress->prglstval := p003Frm.prglstval.Value
 IF p003Frm.FormStatus.Value == "2" .AND. lRiattiva
  progress->(DBRECALL())
 ENDIF
 p003_UpdGrid()
 progress->(DBCOMMIT())
ENDIF
RETURN lDone

/****************************************************************
* Update p003grid1
****************************************************************/
STATIC FUNCTION p003_UpdGrid()
* IF p003_nGrid == 0 must be added else update
IF p003_nGrid == 0
 aTemp := {"", CTOD(""), 0}
ELSE
 aTemp := GetProperty( "p002Frm", "grid1", "item", p003_nGrid)
ENDIF
aTemp[1] := p003Frm.prgidcode.Value
aTemp[2] := p003Frm.prgdescri.Value
aTemp[3] := p003Frm.prglstval.Value
* IF p003_nGrid == 0 must be added else update
IF p003_nGrid == 0
 DoMethod("p002Frm", "grid1", "additem", aTemp)
 p003_nGrid := GetProperty("p003Frm", "grid1", "ItemCount")
 SetProperty("p002Frm", "grid1", "Value", p003_nGrid )
ELSE
 SetProperty( "p002Frm", "grid1", "item", p003_nGrid, aTemp )
ENDIF

RETURN NIl

/****************************************************************
* Errors check
****************************************************************/
STATIC FUNCTION p003_CheckData()
LOCAL lItsOk := .T.
*lItsOk := IF(lItsOk==.T., p003_prgidcode(), lItsOk)
lItsOk := IF(lItsOk==.T., p003_prgdescri(), lItsOk)
lItsOk := IF(lItsOk==.T., p003_prglstval(), lItsOk)
RETURN lItsOk

/****************************************************************
* prgidcode error
****************************************************************/
STATIC FUNCTION p003_prgidcode()
LOCAL lItsOk := .T.
IF LEN( ALLTRIM( p003Frm.prgidcode.Value ) ) == 0
 lItsOk := .F.
 MSGSTOP("Enter a valid code", "p003_prgidcode()")
 p003Frm.prgidcode.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* prgdescri error
****************************************************************/
STATIC FUNCTION p003_prgdescri()
LOCAL lItsOk := .T.
IF LEN(ALLTRIM(p003Frm.prgdescri.Value)) == 0
  lItsOk := .F.
  MSGSTOP("Enter a valid description","p003_prgdescri()")
  p003Frm.prgdescri.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* prglstval error
****************************************************************/
STATIC FUNCTION p003_prglstval()
LOCAL lItsOk := .T.
IF p003Frm.prglstval.Value < 0
  lItsOk := .F.
  MSGSTOP("Enter a valid value","p003_prglstval()")
  p003Frm.prglstval.SetFocus
ENDIF
RETURN lItsOk

/****************************************************************
* public functions
****************************************************************/

/*
* get a new progressive value
*/
FUNCTION p003_getprogr(cQuale, nValore)
LOCAL lRetvalue := .F.
LOCAL nLastord := progress->(ORDSETFOCUS(1))
LOCAL nLastrec := progress->(RECNO())
LOCAL cKey := FillKey( cQuale, 8 )

* find record
IF progress->(DBSEEK(cKey, .F.)) == .T.
 IF Reclock("progress") == .T.
  progress->admintstp := HB_TTOS(HB_DATETIME())
  progress->prglstval += 1
  nValore := progress->prglstval
  progress->(DBCOMMIT())
  progress->(DBUNLOCK())
  lRetvalue := .T.
 ELSE
  MSGSTOP("Record LOCKED","p003_getprogr()")
 ENDIF
ELSE
 MSGSTOP(cKey + " progressive not found","p003_getprogr()")
ENDIF
progress->(DBGOTO(nLastrec))
progress->(ORDSETFOCUS(nLastord))
RETURN lRetvalue