/*
*  AQUARIUM - find taquanag
*/

#include "aquarium.ch"

/*
* p004Frm definition
*/
FUNCTION p004Frm_Define()
LOCAL aGcol1 := {"TEXTBOX", "CHARACTER"}
LOCAL aGcol3 := {"TEXTBOX", "NUMERIC", "99,999,999", "99,999,999"}
LOCAL aGrdHead := {"Code","Description","Value"}
LOCAL aGrdWidt := {100,300,150}
LOCAL aGrdCols := {aGcol1, aGcol1, aGcol3}
LOCAL aGrdJust := {GRID_JTFY_LEFT, GRID_JTFY_LEFT, GRID_JTFY_RIGHT}

SET NAVIGATION EXTENDED
DEFINE WINDOW p004Frm ;
 ROW 0 ;
 COL 0 ;
 WIDTH 860 ;
 HEIGHT 645 ;
 WINDOWTYPE STANDARD ;
 TITLE "Aquarium FINDER (p004Frm)" ;
 ICON "MAIN_ICO" ;
 VISIBLE .T. ;
 MINBUTTON .T. ;
 MAXBUTTON .F. ;
 SIZABLE .F. ;
 SYSMENU .T. ;
 TITLEBAR .T. ;
 ON INIT Nil ;
 ON RELEASE Nil ;
 ON INTERACTIVECLOSE p004Frm_OnIntClose() ;
 ON MOUSECLICK Nil ;
 ON MOUSEDRAG Nil ;
 ON MOUSEMOVE Nil ;
 ON SIZE Nil ;
 ON MAXIMIZE Nil ;
 ON MINIMIZE Nil ;
 ON PAINT Nil ;
 FONTNAME FRMFNAME FONTSIZE FRMFSIZE ;
 ON NOTIFYCLICK Nil ;
 ON GOTFOCUS Nil ;
 ON LOSTFOCUS Nil ;
 ON SCROLLUP Nil ;
 ON SCROLLDOWN Nil ;
 ON SCROLLLEFT Nil ;
 ON SCROLLRIGHT Nil ;
 ON HSCROLLBOX Nil ;
 ON VSCROLLBOX Nil

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT BUTFNAME ;
  SIZE BUTFSIZE ;
  FLAT ;
  BORDER
  BUTTON btExit ;
   CAPTION 'e&Xit' ;
   PICTURE "BTEXIT" ;
   ACTION p004_Exit() ;
   SEPARATOR
  BUTTON btSelect ;
   CAPTION '&Select' ;
   PICTURE "BTTICK" ;
   ACTION p004_DblClick() ;
   SEPARATOR
  BUTTON btAddrec ;
   CAPTION '&Add' ;
   PICTURE "BTRECADD" ;
   ACTION p004_Addrec() ;
   SEPARATOR
  BUTTON btEdit ;
   CAPTION '&Edit' ;
   PICTURE "BTRECEDIT" ;
   ACTION p004_Editrec() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "AQUARIUM" WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* E=empty form, 0=form in use and record not found, 1=form in use and record found and lock, 2=form in use and record found and lock and already deleted
 DEFINE LABEL FormStatus
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "E"
  VISIBLE .F.
 END LABEL

 DEFINE TAB tab1 ;
  AT 50,10 ;
  WIDTH 840 ;
  HEIGHT 450 ;
  VALUE 1 ;
  TOOLTIP "Select"

  DEFINE PAGE "&Data"

* define grid
   DEFINE GRID grid1
    ROW 60
    COL 20
    WIDTH 800
    HEIGHT 350
    TOOLTIP "Double click to select"
    ONGOTFOCUS Nil
    ONLOSTFOCUS Nil
    ONSAVE Nil
    ONCHANGE Nil
    ONHEADCLICK { {||p004_ChgOrd(1)}, {||p004_ChgOrd(2)}, {||p004_ChgOrd(1)} }
    ONQUERYDATA Nil
    ONDBLCLICK p004_DblClick()
    HEADERS aGrdHead
    WIDTHS aGrdWidt
    COLUMNCONTROLS aGrdCols
    JUSTIFY aGrdJust
   END GRID

  END PAGE
  DEFINE PAGE "&Filter"

*  fltdescri
   DEFINE LABEL lb_fltdescri
    ROW 60
    COL 20
    VALUE 'Description'
    WIDTH 100
    HEIGHT 25
    ALIGNMENT Left
   END LABEL
   DEFINE TEXTBOX fltdescri
    ROW 60
    COL 125
    HEIGHT 25
    WIDTH 300
    TOOLTIP 'Text to find'
    MAXLENGTH 255
   END TEXTBOX

  END PAGE
 END TAB

* bottone bt_setfilter
   DEFINE BUTTON bt_setfilter
    ROW 530
    COL 220
    CAPTION "Reload"
    PICTURE "BTREFRESH"
    PICTALIGNMENT Left
    ONCLICK p004_LoadForm()
    WIDTH 120
    HEIGHT 30
    FONTBOLD .F.
    FONTITALIC .F.
    FONTUNDERLINE .F.
    FONTSTRIKEOUT .F.
    TOOLTIP 'Click to apply filter'
    FLAT .T.
    TRANSPARENT .T.
    ONGOTFOCUS Nil
    ONLOSTFOCUS Nil
    TABSTOP .T.
    VISIBLE .T.
    MULTILINE .F.
   END BUTTON
* bottone bt_clrfilter
   DEFINE BUTTON bt_clrfilter
    ROW 530
    COL 500
    CAPTION "Clear filter"
    PICTURE "BTCLEAR"
    PICTALIGNMENT Left
    ONCLICK {|| p004_FormReset(), p004_LoadForm() }
    WIDTH 120
    HEIGHT 30
    FONTBOLD .F.
    FONTITALIC .F.
    FONTUNDERLINE .F.
    FONTSTRIKEOUT .F.
    TOOLTIP 'Click to clear filter'
    FLAT .T.
    TRANSPARENT .T.
    ONGOTFOCUS Nil
    ONLOSTFOCUS Nil
    TABSTOP .T.
    VISIBLE .T.
    MULTILINE .F.
   END BUTTON

END WINDOW

p004Frm.Center
RETURN NIL

/****************************************************************
* pgm002 Entry function
* aParm[1] = form name to assign focus when leave this form
* aParm[2] = control name (about prev. form name) to assign focus when leave this form
* aParm[3] = control name (about prev. form name) to assign a value from grid of this form
* aParm[n] = control name (about prev. form name) to assign a value from grid of this form
* cCode = if passed when load grid set Grid.Value else is set to 1
****************************************************************/
FUNCTION p004_Main( aParm, cCode)
LOCAL lReturn := .F.
IF IsFomFree( "p004Frm", "FormStatus", "E" )
 p004_ShowForm( aParm, cCode)
 lReturn := .T.
ELSE
 p004_NewFocus(aParm)
ENDIF
RETURN lReturn

/****************************************************************
* Show form
****************************************************************/
STATIC FUNCTION p004_ShowForm( aParm, cCode)
PUBLIC p004_nOrder := 1
PUBLIC p004_aParm := IF( VALTYPE( aParm ) == "A", aParm, {} )
PUBLIC p004_cCode := IF( VALTYPE( cCode ) == "C", cCode, "" )
p004Frm.Restore
p004Frm.Setfocus
p004_FormReset()
p004_ChgOrd(2)
RETURN NIL

/****************************************************************
* Set New Focus
* __MVEXIST, __MVGET, __MVPUT are little trick because p004_aParm is declared PUBLIC inside in p004_ShowForm function
* but p004_NewFocus can be called from p004_Main and p004_aParm it's not declared!
****************************************************************/
STATIC FUNCTION p004_NewFocus( aParm )
LOCAL aNewFocus := IF( VALTYPE( aParm ) == "A", aParm, IF( __MVEXIST("p004_aParm"), __MVGET("p004_aParm"), {} ) )
IF LEN(aNewFocus)>=1
 DoMethod(aNewFocus[1], "Restore" )
 IF LEN(aNewFocus)==1
  DoMethod(aNewFocus[1], "SetFocus")
 ELSEIF LEN(aNewFocus)>=2
  DoMethod(aNewFocus[1], aNewFocus[2], "SetFocus")
 ENDIF
ENDIF
IF __MVEXIST("p004_aParm")
 __MVPUT("p004_aParm", {})
ENDIF
RETURN NIL

/****************************************************************
* p004Frm OnIntercativeClose event
****************************************************************/
STATIC FUNCTION p004Frm_OnIntClose()
p004_FormReset()
p004_NewFocus()
RETURN NIL

/****************************************************************
* Exit function
****************************************************************/
STATIC FUNCTION p004_Exit()
p004_FormReset()
p004Frm.Hide
p004_NewFocus()
RETURN NIL

/****************************************************************
* Select function
****************************************************************/
STATIC FUNCTION p004_DblClick()
LOCAL aTemp := {}
IF p004Frm.grid1.Value <> 0
 aTemp := p004Frm.grid1.Item( p004Frm.grid1.Value )
 IF LEN(p004_aParm) >= 3
  SetProperty( p004_aParm[1], p004_aParm[3], "Value", aTemp[1] )
 ENDIF
 p004_FormReset()
 p004Frm.Hide
 p004_NewFocus()
ENDIF
RETURN NIL

/****************************************************************
* Addrec function
****************************************************************/
STATIC FUNCTION p004_Addrec()
IF p005_Main({"p004Frm", "grid1"}, 0 )
 p004Frm.Hide
ENDIF
RETURN NIL

/****************************************************************
* Editrec function
****************************************************************/
STATIC FUNCTION p004_Editrec()
IF p004Frm.grid1.Value <> 0
 IF p005_Main({"p004Frm", "grid1"}, p004Frm.grid1.Value )
  p004Frm.Hide
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Form Reset function
****************************************************************/
STATIC FUNCTION p004_FormReset()
p004Frm.FormStatus.Value := "E"
p004Frm.tab1.Value := 1
p004Frm.grid1.DeleteAllItems
p004Frm.fltdescri.Value := ""
RETURN NIL

/****************************************************************
* Change Order
****************************************************************/
STATIC FUNCTION p004_ChgOrd(nOrd)
p004_nOrder := nOrd
taquanag->(ORDSETFOCUS(p004_nOrder))
p004_LoadForm()
RETURN NIL

/****************************************************************
* Load form function
****************************************************************/
STATIC FUNCTION p004_LoadForm()
LOCAL nGrid := 1
* commit form
p004Frm.FormStatus.Value := "0"
taquanag->(DBGOTOP())
p004Frm.grid1.DeleteAllItems
DO WHILE !taquanag->(EOF())
 IF p004_Filter()
  p004Frm.grid1.AddItem( {taquanag->taqidcode, taquanag->taqdescri, taquanag->taqchgday} )
  IF LEN(ALLTRIM(p004_cCode)) > 0 .AND. ALLTRIM(p004_cCode) == ALLTRIM(taquanag->taqidcode)
   nGrid := p004Frm.grid1.ItemCount
  ENDIF
 ENDIF
 taquanag->(DBSKIP(+1))
ENDDO

p004Frm.grid1.Value := IF( nGrid > 0, nGrid, 1 )
p004Frm.tab1.Value := 1
p004Frm.grid1.Refresh
p004Frm.grid1.Setfocus
RETURN NIL

/****************************************************************
* Apply filter
****************************************************************/
STATIC FUNCTION p004_Filter()
LOCAL lAddRow := .T.

IF LEN(ALLTRIM(p004Frm.fltdescri.Value)) <> 0 .AND. ;
  AT(LOWER(ALLTRIM(p004Frm.fltdescri.Value)), LOWER(ALLTRIM(taquanag->taqdescri))) == 0
 lAddRow := .F.
ENDIF

RETURN lAddRow
