/*
*  AQUARIUM - find chgwater
*/

#include "aquarium.ch"

/*
* p100Frm definition
*/
FUNCTION p100Frm_Define()
LOCAL aGcol1 := {"TEXTBOX", "CHARACTER"}
LOCAL aGcol2 := {"TEXTBOX", "CHARACTER"}
LOCAL aGcol3 := {"TEXTBOX", "DATE"}
LOCAL aGcol4 := {"TEXTBOX", "NUMERIC", "999,999.99", "99,999,999", 999,999.99}
LOCAL aGcol5 := {"TEXTBOX", "CHARACTER"}
LOCAL aGrdHead := {"Aquarium","Description","Date","Liters","Notes"}
LOCAL aGrdWidt := {100,100,100,100,100}
LOCAL aGrdCols := {aGcol1, aGcol2, aGcol3, aGcol4, aGcol5}
LOCAL aGrdJust := {GRID_JTFY_LEFT, GRID_JTFY_LEFT, GRID_JTFY_CENTER, GRID_JTFY_RIGHT, GRID_JTFY_LEFT}

SET NAVIGATION EXTENDED
DEFINE WINDOW p100Frm ;
 ROW 0 ;
 COL 0 ;
 WIDTH 860 ;
 HEIGHT 645 ;
 WINDOWTYPE STANDARD ;
 TITLE "Change Water FINDER (p100Frm)" ;
 ICON "MAIN_ICO" ;
 VISIBLE .T. ;
 MINBUTTON .T. ;
 MAXBUTTON .F. ;
 SIZABLE .F. ;
 SYSMENU .T. ;
 TITLEBAR .T. ;
 ON INIT Nil ;
 ON RELEASE Nil ;
 ON INTERACTIVECLOSE p100Frm_OnIntClose() ;
 ON MOUSECLICK Nil ;
 ON MOUSEDRAG Nil ;
 ON MOUSEMOVE Nil ;
 ON SIZE Nil ;
 ON MAXIMIZE Nil ;
 ON MINIMIZE Nil ;
 ON PAINT Nil ;
 FONTNAME FRMFNAME FONTSIZE FRMFSIZE ;
 ON NOTIFYCLICK Nil ;
 ON GOTFOCUS Nil ;
 ON LOSTFOCUS Nil ;
 ON SCROLLUP Nil ;
 ON SCROLLDOWN Nil ;
 ON SCROLLLEFT Nil ;
 ON SCROLLRIGHT Nil ;
 ON HSCROLLBOX Nil ;
 ON VSCROLLBOX Nil

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT BUTFNAME ;
  SIZE BUTFSIZE ;
  FLAT ;
  BORDER
  BUTTON btExit ;
   CAPTION 'e&Xit' ;
   PICTURE "BTEXIT" ;
   ACTION p100_Exit() ;
   SEPARATOR
  BUTTON btSelect ;
   CAPTION '&Select' ;
   PICTURE "BTTICK" ;
   ACTION p100_DblClick() ;
   SEPARATOR
  BUTTON btAddrec ;
   CAPTION '&Add' ;
   PICTURE "BTRECADD" ;
   ACTION p100_Addrec() ;
   SEPARATOR
  BUTTON btEdit ;
   CAPTION '&Edit' ;
   PICTURE "BTRECEDIT" ;
   ACTION p100_Editrec() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "AQUARIUM" WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* E=empty form, 0=form in use and record not found, 1=form in use and record found and lock, 2=form in use and record found and lock and already deleted
 DEFINE LABEL FormStatus
  ROW 20
  COL 500
  WIDTH 20
  HEIGHT 20
  VALUE "E"
  VISIBLE .F.
 END LABEL

 DEFINE TAB tab1 ;
  AT 50,10 ;
  WIDTH 840 ;
  HEIGHT 450 ;
  VALUE 1 ;
  TOOLTIP "Select"

  DEFINE PAGE "&Data"

* define grid
   DEFINE GRID grid1
    ROW 60
    COL 20
    WIDTH 800
    HEIGHT 350
    TOOLTIP "Double click to select"
    ONGOTFOCUS Nil
    ONLOSTFOCUS Nil
    ONSAVE Nil
    ONCHANGE Nil
    ONHEADCLICK { {||p100_ChgOrd(1)}, {||p100_ChgOrd(2)}, {||p100_ChgOrd(1)} }
    ONQUERYDATA Nil
    ONDBLCLICK p100_DblClick()
    HEADERS aGrdHead
    WIDTHS aGrdWidt
    COLUMNCONTROLS aGrdCols
    JUSTIFY aGrdJust
   END GRID

  END PAGE
  DEFINE PAGE "&Filter"

*  fltidcode
   DEFINE LABEL lb_fltidcode
    ROW 60
    COL 20
    VALUE 'Code'
    WIDTH 100
    HEIGHT 25
    ALIGNMENT Left
   END LABEL
   DEFINE TEXTBOX fltidcode
    ROW 60
    COL 125
    HEIGHT 25
    WIDTH 100
    TOOLTIP 'Text to find'
    MAXLENGTH 8
   END TEXTBOX

*  fltdescri
   DEFINE LABEL lb_fltdescri
    ROW 90
    COL 20
    VALUE 'Description'
    WIDTH 100
    HEIGHT 25
    ALIGNMENT Left
   END LABEL
   DEFINE TEXTBOX fltdescri
    ROW 90
    COL 125
    HEIGHT 25
    WIDTH 300
    TOOLTIP 'Text to find'
    MAXLENGTH 255
   END TEXTBOX

  END PAGE
 END TAB

* bottone bt_setfilter
   DEFINE BUTTON bt_setfilter
    ROW 530
    COL 220
    CAPTION "Reload"
    PICTURE "BTREFRESH"
    PICTALIGNMENT Left
    ONCLICK p100_LoadForm()
    WIDTH 120
    HEIGHT 30
    FONTBOLD .F.
    FONTITALIC .F.
    FONTUNDERLINE .F.
    FONTSTRIKEOUT .F.
    TOOLTIP 'Click to apply filter'
    FLAT .T.
    TRANSPARENT .T.
    ONGOTFOCUS Nil
    ONLOSTFOCUS Nil
    TABSTOP .T.
    VISIBLE .T.
    MULTILINE .F.
   END BUTTON
* bottone bt_clrfilter
   DEFINE BUTTON bt_clrfilter
    ROW 530
    COL 500
    CAPTION "Clear filter"
    PICTURE "BTCLEAR"
    PICTALIGNMENT Left
    ONCLICK {|| p100_FormReset(), p100_LoadForm() }
    WIDTH 120
    HEIGHT 30
    FONTBOLD .F.
    FONTITALIC .F.
    FONTUNDERLINE .F.
    FONTSTRIKEOUT .F.
    TOOLTIP 'Click to clear filter'
    FLAT .T.
    TRANSPARENT .T.
    ONGOTFOCUS Nil
    ONLOSTFOCUS Nil
    TABSTOP .T.
    VISIBLE .T.
    MULTILINE .F.
   END BUTTON

END WINDOW

p100Frm.Center
RETURN NIL

/****************************************************************
* pgm002 Entry function
* aParm[1] = form name to assign focus when leave this form
* aParm[2] = control name (about prev. form name) to assign focus when leave this form
* aParm[3] = control name (about prev. form name) to assign a value from grid of this form
* aParm[n] = control name (about prev. form name) to assign a value from grid of this form
* cCode = if passed when load grid set Grid.Value else is set to 1
****************************************************************/
FUNCTION p100_Main( aParm, cCode)
LOCAL lReturn := .F.
IF IsFomFree( "p100Frm", "FormStatus", "E" )
 p100_ShowForm( aParm, cCode)
 lReturn := .T.
ELSE
 p100_NewFocus(aParm)
ENDIF
RETURN lReturn

/****************************************************************
* Show form
****************************************************************/
STATIC FUNCTION p100_ShowForm( aParm, cCode)
PUBLIC p100_nOrder := 1
PUBLIC p100_aParm := IF( VALTYPE( aParm ) == "A", aParm, {} )
PUBLIC p100_cCode := IF( VALTYPE( cCode ) == "C", cCode, "" )
p100Frm.Restore
p100Frm.Setfocus
p100_FormReset()
p100_ChgOrd(2)
RETURN NIL

/****************************************************************
* Set New Focus
* __MVEXIST, __MVGET, __MVPUT are little trick because p100_aParm is declared PUBLIC inside in p100_ShowForm function
* but p100_NewFocus can be called from p100_Main and p100_aParm it's not declared!
****************************************************************/
STATIC FUNCTION p100_NewFocus( aParm )
LOCAL aNewFocus := IF( VALTYPE( aParm ) == "A", aParm, IF( __MVEXIST("p100_aParm"), __MVGET("p100_aParm"), {} ) )
IF LEN(aNewFocus)>=1
 DoMethod(aNewFocus[1], "Restore" )
 IF LEN(aNewFocus)==1
  DoMethod(aNewFocus[1], "SetFocus")
 ELSEIF LEN(aNewFocus)>=2
  DoMethod(aNewFocus[1], aNewFocus[2], "SetFocus")
 ENDIF
ENDIF
IF __MVEXIST("p100_aParm")
 __MVPUT("p100_aParm", {})
ENDIF
RETURN NIL

/****************************************************************
* p100Frm OnIntercativeClose event
****************************************************************/
STATIC FUNCTION p100Frm_OnIntClose()
p100_FormReset()
p100_NewFocus()
RETURN NIL

/****************************************************************
* Exit function
****************************************************************/
STATIC FUNCTION p100_Exit()
p100_FormReset()
p100Frm.Hide
p100_NewFocus()
RETURN NIL

/****************************************************************
* Select function
****************************************************************/
STATIC FUNCTION p100_DblClick()
LOCAL aTemp := {}
IF p100Frm.grid1.Value <> 0
 aTemp := p100Frm.grid1.Item( p100Frm.grid1.Value )
 IF LEN(p100_aParm) >= 3
  SetProperty( p100_aParm[1], p100_aParm[3], "Value", aTemp[1] )
 ENDIF
 p100_FormReset()
 p100Frm.Hide
 p100_NewFocus()
ENDIF
RETURN NIL

/****************************************************************
* Addrec function
****************************************************************/
STATIC FUNCTION p100_Addrec()
IF p101_Main( {"p100Frm", "grid1"}, 0 )
 p100Frm.Hide
ENDIF
RETURN NIL

/****************************************************************
* Editrec function
****************************************************************/
STATIC FUNCTION p100_Editrec()
IF p100Frm.grid1.Value <> 0
 IF p101_Main({"p100Frm", "grid1"}, p100Frm.grid1.Value)
  p100Frm.Hide
 ENDIF
ENDIF
RETURN NIL

/****************************************************************
* Form Reset function
****************************************************************/
STATIC FUNCTION p100_FormReset()
p100Frm.FormStatus.Value := "E"
p100Frm.tab1.Value := 1
p100Frm.grid1.DeleteAllItems
p100Frm.fltdescri.Value := ""
p100Frm.fltidcode.Value := ""
RETURN NIL

/****************************************************************
* Change Order
****************************************************************/
STATIC FUNCTION p100_ChgOrd(nOrd)
p100_nOrder := nOrd
chgwater->(ORDSETFOCUS(p100_nOrder))
p100_LoadForm()
RETURN NIL

/****************************************************************
* Load form function
****************************************************************/
STATIC FUNCTION p100_LoadForm()
LOCAL nGrid := 1
LOCAL aRetFields := {}

* commit form
p100Frm.FormStatus.Value := "0"
chgwater->(DBGOTOP())
p100Frm.grid1.DeleteAllItems
DO WHILE !chgwater->(EOF())
 IF p100_Filter()
  aRetFields := p005_GetRecord( chgwater->chwidaqua )
  p100Frm.grid1.AddItem( {chgwater->chwidaqua, aRetFields[2], STOD(chgwater->chwdatech), chgwater->chwliters, chgwater->chwnotess} )
  IF LEN(ALLTRIM(p100_cCode)) > 0 .AND. ALLTRIM(p100_cCode) == ALLTRIM(chgwater->chwidaqua)
   nGrid := p100Frm.grid1.ItemCount
  ENDIF
 ENDIF
 chgwater->(DBSKIP(+1))
ENDDO

p100Frm.grid1.Value := IF( nGrid > 0, nGrid, 1 )
p100Frm.tab1.Value := 1
p100Frm.grid1.Refresh
p100Frm.grid1.Setfocus
RETURN NIL

/****************************************************************
* Apply filter
****************************************************************/
STATIC FUNCTION p100_Filter()
LOCAL lAddRow := .T.

IF LEN(ALLTRIM(p100Frm.fltidcode.Value)) <> 0 .AND. ;
  AT(LOWER(ALLTRIM(p100Frm.fltidcode.Value)), LOWER(ALLTRIM(chgwater->chwidaqua))) == 0
 lAddRow := .F.
ENDIF

IF LEN(ALLTRIM(p100Frm.fltdescri.Value)) <> 0 .AND. ;
  AT(LOWER(ALLTRIM(p100Frm.fltdescri.Value)), LOWER(ALLTRIM(chgwater->chwnotess))) == 0
 lAddRow := .F.
ENDIF

RETURN lAddRow
