/*
*  AQUARIUM - check status
*/

#include "aquarium.ch"

FUNCTION p999Frm_Define()

SET NAVIGATION EXTENDED
DEFINE WINDOW p999Frm ;
 ROW 0 ;
 COL 0 ;
 WIDTH 700 ;
 HEIGHT 525 ;
 TITLE "Water STATUS (p999Frm)" ;
 ICON "MAIN_ICO" ;
 MODAL ;
 ON INIT Nil ;
 ON RELEASE Nil ;
 ON INTERACTIVECLOSE Nil ;
 ON MOUSECLICK Nil ;
 ON MOUSEDRAG Nil ;
 ON MOUSEMOVE Nil ;
 ON SIZE Nil ;
 ON PAINT Nil ;
 ON GOTFOCUS Nil ;
 ON LOSTFOCUS Nil ;
 ON SCROLLUP Nil ;
 ON SCROLLDOWN Nil ;
 ON SCROLLLEFT Nil ;
 ON SCROLLRIGHT Nil ;
 ON HSCROLLBOX Nil ;
 ON VSCROLLBOX Nil ;
 FONTNAME FRMFNAME FONTSIZE FRMFSIZE

 DEFINE TOOLBAR toolbar1 ;
  BUTTONSIZE 60,30 ;
  FONT BUTFNAME ;
  SIZE BUTFSIZE ;
  FLAT ;
  BORDER
  BUTTON btExit ;
   CAPTION 'e&Xit' ;
   PICTURE "BTEXIT" ;
   ACTION p999_Exit() ;
   SEPARATOR
 END TOOLBAR

 DEFINE STATUSBAR
  STATUSITEM "AQUARIUM" WIDTH 250
  CLOCK WIDTH 80
  DATE WIDTH 100
 END STATUSBAR

* field statusnote
 DEFINE EDITBOX statusnote
  ROW 60
  COL 125
  HEIGHT 300
  WIDTH 400
  VALUE ""
  FONTBOLD .F.
  FONTITALIC .F.
  FONTUNDERLINE .F.
  FONTSTRIKEOUT .F.
  TOOLTIP 'Status'
  ONGOTFOCUS Nil
  ONCHANGE Nil
  ONLOSTFOCUS Nil
  TABSTOP .T.
  VISIBLE .T.
  READONLY .T.
  VSCROLLBAR .T.
  HSCROLLBAR .T.
 END EDITBOX

END WINDOW

p999Frm.Center

RETURN NIL

/****************************************************************
* Exit event
****************************************************************/
STATIC FUNCTION p999_Exit()
p999Frm.Hide
RETURN NIL

/****************************************************************
* Check status
****************************************************************/
FUNCTION p999_Main()
LOCAL aAquari := {}, nPerDay := 0, nDay := 0, nPerCent := 0, nLiters := 0, nX := 0, cMessage := "", lAlert := .F.

* find any aquarium
taquanag->(ORDSETFOCUS(1))
taquanag->(DBGOTOP())
DO WHILE !taquanag->(EOF())
 nPerDay := IF( taquanag->taqchgday > 0, ROUND( taquanag->taqchgper / taquanag->taqchgday, 3 ), 0 )
 AADD( aAquari, {taquanag->taqidcode,taquanag->taqdescri,taquanag->taqnetlit,taquanag->taqchgper,taquanag->taqchgday, nPerDay, "", 0} )
 taquanag->(DBSKIP(+1))
ENDDO

* find any water change
chgwater->(ORDSETFOCUS(1))
chgwater->(DBGOTOP())
DO WHILE !chgwater->(EOF())
 nX := ASCAN( aAquari, {|x| x[1]==chgwater->chwidaqua } )
 IF nX <> 0
  aAquari[nX,7] := STOD(chgwater->chwdatech)
  aAquari[nX,8] := chgwater->chwpercen
 ENDIF
 chgwater->(DBSKIP(+1))
ENDDO

FOR nX := 1 TO LEN( aAquari )
 IF VALTYPE(aAquari[nX,7]) == "C"
*  MSGSTOP( "You must change 100% of water in " + aAquari[nX,1] )
  cMessage += "You must change 100% of water in aquarium code " + aAquari[nX,1] + HB_OSNEWLINE()
  lAlert := .T.
 ELSE
  nDay := DATE() - aAquari[nX,7]
  IF nDay >= aAquari[nX,5]
   nPerCent := ROUND( nDay * aAquari[nX,6], 0 )
   IF aAquari[nX,8] < aAquari[nX,4]
    nPerCent += aAquari[nX,4] - aAquari[nX,8]
   ENDIF
*   MSGSTOP( "You must change " + LTRIM(STR(nPerDay)) + "% of water in " + aAquari[nX,1] )
   cMessage += "You must change " + LTRIM(STR(nPerCent)) + "% of water in aquarium code " + aAquari[nX,1] + HB_OSNEWLINE()
  lAlert := .T.
  ENDIF
 ENDIF
NEXT nX

IF lAlert
 p999Frm.statusnote.Value := cMessage
 p999Frm.Show
ENDIF

RETURN NIL
